'use strict';

var CotacaoServices = angular.module('CotacaoServices', []);

CotacaoServices.factory('Cotacao', ['Conexao',
    (Conexao) => {

        var cotacaoFactory = {};

        cotacaoFactory.setCotacao = (cotacao, callBackFunction) => {
            Conexao.ExecutaService('setCotacao', cotacao, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        cotacaoFactory.delCotacao = (cotacao, callBackFunction) => {
            Conexao.ExecutaService('delCotacao', cotacao, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        cotacaoFactory.getResumoCotacaoFornecedores = (params, callBackFunction) => {
            Conexao.ExecutaService('getResumoCotacaoFornecedores', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        cotacaoFactory.getSelecionadosCotacao = (params, callBackFunction) => {
            Conexao.ExecutaService('getSelecionadosCotacao', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        cotacaoFactory.getCotacaoFornecedores = (params, callBackFunction) => {
            Conexao.ExecutaService('getCotacaoFornecedores', params, false,
                (data) => {
                    callBackFunction(data);
                });
        }

        cotacaoFactory.setValorCotacaoFornecedor = (cotacaoItem, callBackFunction) => {
            Conexao.ExecutaService('setValorCotacaoFornecedor', cotacaoItem, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        cotacaoFactory.setValorCotacaoFornecedores = (params, callBackFunction) => {
            var paramsPost = {
                POST: true,
                data: params
            }
            Conexao.ExecutaService('setValorCotacaoFornecedoresPost', paramsPost, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        cotacaoFactory.setSelecionadoCotacao = function (cotacao, callBackFunction) {
            Conexao.ExecutaService('setSelecionadoCotacao', cotacao, false,
                function (data) {
                    callBackFunction(data);
                });
        }

        cotacaoFactory.delSelecionadoCotacao = function (cotacao, callBackFunction) {
            Conexao.ExecutaService('delSelecionadoCotacao', cotacao, false,
                function (data) {
                    callBackFunction(data);
                });
        }

        cotacaoFactory.setFornecedoresCotacao = (params, callBackFunction) => {
            Conexao.ExecutaService('setFornecedoresCotacao', params, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        cotacaoFactory.setEmailCotacao = (params, callBackFunction) => {
            Conexao.ExecutaService('setEmailCotacao', params, true,
                (data) => {
                    callBackFunction(data);
                });
        }
        
        cotacaoFactory.reenvioEmailCotacao = (params, callBackFunction) => {
            Conexao.ExecutaService('reenvioEmailCotacao', params, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        cotacaoFactory.getMapaCotacao = (params, callBackFunction) => {
            Conexao.ExecutaService('getMapaCotacao', params, true,
                (data) => {
                    callBackFunction(data);
                });
        }

        cotacaoFactory.xlsMapaCotacao = (params, callBackFunction) => {
            Conexao.ExecutaService('xlsMapaCotacao', params, true,
                (data) => {
                    callBackFunction(data);
                });
        }
        
        cotacaoFactory.setDataEntregaVencimentoCotacao = (cotacoes, callBackFunction) => {
            var params = {
                POST: true,
                data: cotacoes
            }
            Conexao.ExecutaService('setDataEntregaVencimentoCotacao', params, true,
                (data) => {
                    callBackFunction(data);
                });
        }
    
        return cotacaoFactory;
    }
]);
